/***************************************************************************
 *   Copyright (C) 2010 by Naomasa Matsubayashi   *
 *   fadis@quaternion.sakura.ne.jp   *
 *                                                                         *
 *   All rights reserved.                                                  *
 *                                                                         *
 * Redistribution and use in source and binary forms, with or without      *
 * modification, are permitted provided that the following conditions are  *
 * met:                                                                    *
 *                                                                         *
 *  1. Redistributions of source code must retain the above copyright      *
 *     notice, this list of conditions and the following disclaimer.       *
 *  2. Redistributions in binary form must reproduce the above copyright   *
 *     notice, this list of conditions and the following disclaimer in the *
 *     documentation and/or other materials provided with the distribution.*
 *                                                                         *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       *
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      *
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   *
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        *
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   *
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   *
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     *
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    *
 ***************************************************************************/

#include <k6x8/draw.h>
#include <k6x8/glyph.h>
#include <k6x8/map.h>
#include <k6x8/conv.h>

const char *fstEUCJP( uint8_t *_buffer, unsigned int _size, const char *_string ) {
  uint16_t converted_string[ _size + 1 ];
  _string = fstEUCJPToInternal( converted_string, _size + 1, _string );
  unsigned int current_charcter;
  unsigned int current_line;
  for( current_charcter = 0; converted_string[ current_charcter ] != (uint16_t)-1; current_charcter++ ) {
    for( current_line = 0; current_line != 5; current_line++ ) {
      _buffer[ current_charcter * 6 + current_line ] =
        fst_glyph[ converted_string[ current_charcter ] * 5 + current_line ];
    }
    _buffer[ current_charcter * 6 + 5 ] = 0;
  }
  for( ; current_charcter != 16; current_charcter++ )
    for( current_line = 0; current_line != 6; current_line++ )
       _buffer[ current_charcter * 6 + current_line ] = 0;
  return _string;
}
